#ifndef _FileHeader_h_
#define _FileHeader_h_

#include <Base.h>
#include <defines/FileHeader.d>

class FileHeader : public Base {
protected:
    char* symbolTablePtr;

protected:
    FileHeader() : Base(XCoffClassTypes_file_header),symbolTablePtr(NULL) {}
    virtual ~FileHeader() {}
    bool verify(uint16_t targetSize);

public:

    FILEHEADER_MACROS_BASIS("For the get_X field macros check the defines directory");

    void initFilePointers(BinaryInputFile* b);
    void print();
    char* getSymbolTablePtr() { return symbolTablePtr; }
    const char* briefName() { return "FileHeader"; }
};

class FileHeader32 : public FileHeader {
protected:
    FILHDR entry;

public:

    FILEHEADER_MACROS_CLASS("For the get_X field macros check the defines directory");

    FileHeader32() { sizeInBytes = Size__32_bit_File_Header; }
    ~FileHeader32() {}
    uint32_t read(BinaryInputFile* b);
    uint32_t instrument(char* buffer,XCoffFileGen* xCoffGen,BaseGen* gen);
};

class FileHeader64 : public FileHeader {
protected:
    FILHDR_64 entry;

public:

    FILEHEADER_MACROS_CLASS("For the get_X field macros check the defines directory");

    FileHeader64() { sizeInBytes = Size__64_bit_File_Header; }
    ~FileHeader64() {}
    uint32_t read(BinaryInputFile* b);
    uint32_t instrument(char* buffer,XCoffFileGen* xCoffGen,BaseGen* gen);
};

#endif /* _FileHeader_h_ */
