#ifndef _LineInfoTable_h_
#define _LineInfoTable_h_

#include <Base.h>
#include <defines/LineInfoTable.d>

class SymbolTable;
class XCoffFile;

class LineInfo {
protected:
    LineInfo() {}
    virtual ~LineInfo() {}
public:
    virtual char* charStream() { __SHOULD_NOT_ARRIVE; return NULL; }
    virtual void print(SymbolTable* symbolTable,uint32_t index);

    LINEINFO_MACROS_BASIS("For the get_X field macros check the defines directory");
};

class LineInfo32 : public LineInfo {
protected:
    LINENO entry;
public:
    LineInfo32() {}
    ~LineInfo32() {}
    char* charStream() { return (char*)&entry; }

    LINEINFO_MACROS_CLASS("For the get_X field macros check the defines directory");

};

class LineInfo64 : public LineInfo {
protected:
    LINENO_64 entry;
public:
    LineInfo64() {}
    ~LineInfo64() {}
    char* charStream() { return (char*)&entry; }

    LINEINFO_MACROS_CLASS("For the get_X field macros check the defines directory");

};

class LineInfoTable : public Base {
protected:
    
    char* lineInfoPointer;
    uint32_t numOfLineInfos;

    LineInfo** lineInfos;

    SymbolTable* symbolTable;

    XCoffFile* xCoffFile;


public:

    LineInfoTable(char* ptr,uint32_t s,XCoffFile* xcoff);
    void print();
    uint32_t read(BinaryInputFile* b);

    void setSymbolTable(SymbolTable* st) { symbolTable = st; }

    XCoffFile* getXCoffFile() { return xCoffFile; }

    uint32_t getNumberOfLineInfos() { return numOfLineInfos; }
    char* getLineInfoPointer() { return lineInfoPointer; }
    LineInfo* getLineInfo(uint32_t idx) { ASSERT(idx >= 0 && idx < numOfLineInfos); return lineInfos[idx]; }

    const char* briefName() { return "LineInfo"; }
    uint32_t instrument(char* buffer,XCoffFileGen* xCoffGen,BaseGen* gen);
};

#endif

