#ifndef _RelocationTable_h_
#define _RelocationTable_h_

#include <Base.h>
#include <defines/RelocationTable.d>

class SymbolTable;
class XCoffFile;

class Relocation {
protected:
    Relocation() {}
    virtual ~Relocation() {}
public:
    virtual char* charStream() { __SHOULD_NOT_ARRIVE; return NULL; }
    virtual void print(SymbolTable* symbolTable,uint32_t index);

    RELOCATION_MACROS_BASIS("For the get_X field macros check the defines directory");
};

class Relocation32 : public Relocation {
protected:
    RELOC entry;
public:
    Relocation32() {}
    ~Relocation32() {}
    char* charStream() { return (char*)&entry; }

    RELOCATION_MACROS_CLASS("For the get_X field macros check the defines directory");
};

class Relocation64 : public Relocation {
protected:
    RELOC_64 entry;
public:
    Relocation64() {}
    ~Relocation64() {}
    char* charStream() { return (char*)&entry; }

    RELOCATION_MACROS_CLASS("For the get_X field macros check the defines directory");
};

class RelocationTable : public Base {
protected:
    
    char* relocationPtr;
    uint32_t numOfRelocations;

    Relocation** relocations;
    
    SymbolTable* symbolTable;

    XCoffFile* xCoffFile;


public:

    RelocationTable(char* ptr,uint32_t s,XCoffFile* xcoff);
    void print();
    uint32_t read(BinaryInputFile* b);

    void setSymbolTable(SymbolTable* st) { symbolTable = st; }

    XCoffFile* getXCoffFile() { return xCoffFile; }

    const char* briefName() { return "RelocationTable"; }
    uint32_t instrument(char* buffer,XCoffFileGen* xCoffGen,BaseGen* gen);
};

#endif

