/*
##################################################################
XCOFF32     XCOFF64     Name     Description
Offset     Length     Offset     Length
0     2     0     2     o_mflag     Flags, how to execute
2     2     2     2     o_vstamp     Version
4     4     56     8     o_tsize+     Text size in bytes
8     4     64     8     o_dsize+     Initialized data size in bytes
12     4     72     8     o_bsize+     Uninitialized data size in bytes
16     4     80     8     o_entry+     Entry point descriptor (virtual address)
20     4     8     8     o_text_start+     Base address of text (virtual address)
24     4     16     8     o_data_start+     Base address of data (virtual address)
28     4     24     8     o_toc+     Address of TOC anchor
32     2     32     2     o_snentry     Section number for entry point
34     2     34     2     o_sntext     Section number for .text
36     2     36     2     o_sndata     Section number for .data
38     2     38     2     o_sntoc     Section number for TOC
40     2     40     2     o_snloader     Section number for loader data
42     2     42     2     o_snbss     Section number for .bss
44     2     44     2     o_algntext     Maximum alignment for .text
46     2     46     2     o_algndata     Maximum alignment for .data
48     2     48     2     o_modtype     Module type field
50     1     50     1     o_cpuflag     Bit flags - cpu types of objects
51     1     51     1     o_cputype     Reserved for CPU type
52     4     88     8     o_maxstack+     Maximum stack size allowed (bytes)
56     4     96     8     o_maxdata+     Maximum data size allowed (bytes)
60     4     4     4     o_debugger+     Reserved for debuggers.
64     8     52     4     o_resv2     Reserved Field must contain 0s.
0    0     104     116     o_resv3     Reserved. Field must contain 0s.
+Use "32" or "64" suffix when __XCOFF_HYBRID__ is defined.
##################################################################
*/

#define AOUTHEADER_MACROS_BASIS(__str) /** __str **/ \
    GET_FIELD_BASIS(uint16_t,o_mflag); \
    GET_FIELD_BASIS(uint16_t,o_vstamp); \
    GET_FIELD_BASIS(uint64_t,o_tsize); \
    GET_FIELD_BASIS(uint64_t,o_dsize); \
    GET_FIELD_BASIS(uint64_t,o_bsize); \
    GET_FIELD_BASIS(uint64_t,o_entry); \
    GET_FIELD_BASIS(uint64_t,o_text_start); \
    GET_FIELD_BASIS(uint64_t,o_data_start); \
    GET_FIELD_BASIS(uint64_t,o_toc); \
    GET_FIELD_BASIS(uint16_t,o_snentry); \
    GET_FIELD_BASIS(uint16_t,o_sntext); \
    GET_FIELD_BASIS(uint16_t,o_sndata); \
    GET_FIELD_BASIS(uint16_t,o_sntoc); \
    GET_FIELD_BASIS(uint16_t,o_snloader); \
    GET_FIELD_BASIS(uint16_t,o_snbss); \
    GET_FIELD_BASIS(uint16_t,o_algntext); \
    GET_FIELD_BASIS(uint16_t,o_algndata); \
    GET_FIELD_BASIS(uint8_t,o_cpuflag); \
    GET_FIELD_BASIS(uint8_t,o_cputype); \
    GET_FIELD_BASIS(uint64_t,o_maxstack); \
    GET_FIELD_BASIS(uint64_t,o_maxdata); \
    GET_FIELD_BASIS(uint32_t,o_debugger); \
/** END of definitions **/

#define AOUTHEADER_MACROS_CLASS(__str) /** __str **/ \
    GET_FIELD_CLASS(uint16_t,o_mflag); \
    GET_FIELD_CLASS(uint16_t,o_vstamp); \
    GET_FIELD_CLASS(uint64_t,o_tsize); \
    GET_FIELD_CLASS(uint64_t,o_dsize); \
    GET_FIELD_CLASS(uint64_t,o_bsize); \
    GET_FIELD_CLASS(uint64_t,o_entry); \
    GET_FIELD_CLASS(uint64_t,o_text_start); \
    GET_FIELD_CLASS(uint64_t,o_data_start); \
    GET_FIELD_CLASS(uint64_t,o_toc); \
    GET_FIELD_CLASS(uint16_t,o_snentry); \
    GET_FIELD_CLASS(uint16_t,o_sntext); \
    GET_FIELD_CLASS(uint16_t,o_sndata); \
    GET_FIELD_CLASS(uint16_t,o_sntoc); \
    GET_FIELD_CLASS(uint16_t,o_snloader); \
    GET_FIELD_CLASS(uint16_t,o_snbss); \
    GET_FIELD_CLASS(uint16_t,o_algntext); \
    GET_FIELD_CLASS(uint16_t,o_algndata); \
    GET_FIELD_CLASS(uint8_t,o_cpuflag); \
    GET_FIELD_CLASS(uint8_t,o_cputype); \
    GET_FIELD_CLASS(uint64_t,o_maxstack); \
    GET_FIELD_CLASS(uint64_t,o_maxdata); \
    GET_FIELD_CLASS(uint32_t,o_debugger); \
/** END of definitions **/

