/*
##################################################################
XCOFF32     XCOFF64     Name     Description
Offset     Length     Offset     Length
0     2     0     2     f_magic     Target machine
2     2     2     2     f_nscns     Number of sections
4     4     4     4     f_timdat     Time and date of file creation
8     4     8     8     f_symptr+     Byte offset to symbol table start
12     4     20     4     f_nsyms+     Number of entries in symbol table
16     2     16     2     f_opthdr     Number of bytes in optional header
18     2     18     2     f_flags     Flags (see "Field Definitions")
+ Use "32" or "64" suffix when __XCOFF_HYBRID__ is defined.
##################################################################
*/
#define FILEHEADER_MACROS_BASIS(__str) /** __str **/ \
    GET_FIELD_BASIS(uint16_t,f_magic); \
    GET_FIELD_BASIS(uint16_t,f_nscns); \
    GET_FIELD_BASIS(uint32_t,f_timdat); \
    GET_FIELD_BASIS(uint64_t,f_symptr); \
    GET_FIELD_BASIS(uint32_t,f_nsyms); \
    GET_FIELD_BASIS(uint16_t,f_opthdr); \
    GET_FIELD_BASIS(uint16_t,f_flags);

#define FILEHEADER_MACROS_CLASS(__str) /** __str **/ \
    GET_FIELD_CLASS(uint16_t,f_magic); \
    GET_FIELD_CLASS(uint16_t,f_nscns); \
    GET_FIELD_CLASS(uint32_t,f_timdat); \
    GET_FIELD_CLASS(uint64_t,f_symptr); \
    GET_FIELD_CLASS(uint32_t,f_nsyms); \
    GET_FIELD_CLASS(uint16_t,f_opthdr); \
    GET_FIELD_CLASS(uint16_t,f_flags);
