/*
##################################################################
XCOFF32     XCOFF64     Name     Description
Offset     Length     Offset     Length
0     8     0     8     s_name     Section name
8     4     8     8     s_paddr+     Physical address
12     4     16     8     s_vaddr+     Virtual address (same as physical address)
16     4     24     8     s_size+     Section size
20     4     32     8     s_scnptr+     Offset in file to raw data for section
24     4     40     8     s_relptr+     Offset in file to relocation entries for section
28     4     48     8     s_lnnoptr+     Offset in file to line number entries for section
32     2     56     4     s_nreloc+     Number of relocation entries
34     2     60     4     s_nlnno+     Number of line number entries
36     2     64     4     s_flags+     Flags to define the section type
+Use "32" or "64" suffix when __XCOFF_HYBRID__ is defined.
##################################################################
*/

#define SECTION_IS_OF_TYPE_DECL(__str) inline bool is ## __str() { return (GET(s_flags) == STYP_## __str); }
#define IS_SECT_TYPE(__str) is ## __str()

#define SECTHEADER_MACROS_BASIS(__str) /** __str **/ \
    GET_FIELD_BASIS(char*,s_name); \
    GET_FIELD_BASIS(uint64_t,s_paddr); \
    GET_FIELD_BASIS(uint64_t,s_vaddr); \
    GET_FIELD_BASIS(uint64_t,s_size); \
    GET_FIELD_BASIS(uint64_t,s_scnptr); \
    GET_FIELD_BASIS(uint64_t,s_relptr); \
    GET_FIELD_BASIS(uint64_t,s_lnnoptr); \
    GET_FIELD_BASIS(uint32_t,s_nreloc); \
    GET_FIELD_BASIS(uint32_t,s_nlnno); \
    GET_FIELD_BASIS(uint32_t,s_flags); \
    \
    SECTION_IS_OF_TYPE_DECL(TEXT); \
    SECTION_IS_OF_TYPE_DECL(DATA); \
    SECTION_IS_OF_TYPE_DECL(BSS); \
    SECTION_IS_OF_TYPE_DECL(PAD); \
    SECTION_IS_OF_TYPE_DECL(LOADER); \
    SECTION_IS_OF_TYPE_DECL(DEBUG); \
    SECTION_IS_OF_TYPE_DECL(TYPCHK); \
    SECTION_IS_OF_TYPE_DECL(EXCEPT); \
    SECTION_IS_OF_TYPE_DECL(OVRFLO); \
    SECTION_IS_OF_TYPE_DECL(INFO); \
/** END of definitions **/

#define SECTHEADER_MACROS_CLASS(__str) /** __str **/ \
    GET_FIELD_CLASS(char*,s_name); \
    GET_FIELD_CLASS(uint64_t,s_paddr); \
    GET_FIELD_CLASS(uint64_t,s_vaddr); \
    GET_FIELD_CLASS(uint64_t,s_size); \
    GET_FIELD_CLASS(uint64_t,s_scnptr); \
    GET_FIELD_CLASS(uint64_t,s_relptr); \
    GET_FIELD_CLASS(uint64_t,s_lnnoptr); \
    GET_FIELD_CLASS(uint32_t,s_nreloc); \
    GET_FIELD_CLASS(uint32_t,s_nlnno); \
    GET_FIELD_CLASS(uint32_t,s_flags); \
/** END of definitions **/

