#ifndef _CustomDataExtender_h_
#define _CustomDataExtender_h_

#include <CommonMethods.h>

//class CustomDataExtender : public XCoffFileGen {
class CustomDataExtender : public CommonMethods {
public:
    CustomDataExtender(XCoffFile* xcoff, char* extension, char* inptName);
    virtual ~CustomDataExtender() { }

    void selectInstrumentationPoints(char* inpFile);
    void printInstrumentationPoints() {}

    void initializeReservedData(DataSection* dataSect,BaseGen* gen);
    
    uint32_t getNumOfSharedLibFuncs()    { return 1; }

    char*    getSharedLibFuncName(uint32_t i) { 
       assert (i < getNumOfSharedLibFuncs());
       if (i == 0)
          return ("Ohman_endFuncCall");
       return 0;
    }
    void     getSharedLibraryPathAndObj(char** path,char** name,char** obj);

    void     verify(uint32_t written);

    uint32_t maxByteCountPerInst()   { return (64 * sizeof(uint32_t)); }
    uint32_t byteCountForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect);
    uint32_t generateCodeForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect,
                                 BaseGen* gen,uint32_t genBufferOffset);

    uint32_t bytesPerBufferEntry();
    uint32_t howManyBufferEntry()  { return 1; }
    bool filterBlockForInst(BasicBlock* bb) { return false; }
    uint32_t spaceForBlockInfo()   { return 0; }

    char* getGenClassName() { return "CustomDataExtender"; }

private:
   char *inputFile;
   uint32_t extraDataSize;
   uint32_t binaryFile;
};

#endif /* _CustomDataExtender_h_ */
