#include <Base.h>
#include <AOutHeader.h>
#include <BinaryFile.h>

void AOutHeader::print() { 
    PRINT_INFOR("AUXHEADER");
    PRINT_INFOR("\tFlags : %#x",GET(o_mflag));
    PRINT_INFOR("\t#text : %lld (%#llx) in Section %d align %d",GET(o_tsize),GET(o_text_start),GET(o_sntext),GET(o_algntext));
    PRINT_INFOR("\t#data : %lld (%#llx) in Section %d align %d",GET(o_dsize),GET(o_data_start),GET(o_sndata),GET(o_algndata));
    PRINT_INFOR("\t#bss  : %lld in Section %d",GET(o_bsize),GET(o_snbss));
    PRINT_INFOR("\tTOC   : %#llx in Section %d",GET(o_toc),GET(o_sntoc));
    PRINT_INFOR("\tEntry : %#llx in Section %d",GET(o_entry),GET(o_snentry));
    PRINT_INFOR("\tLoade : in Section %d",GET(o_snloader));
    PRINT_INFOR("\tStack : %#llx",GET(o_maxstack));
    PRINT_INFOR("\tMaxda : %#llx",GET(o_maxdata));
}

uint32_t AOutHeader32::read(BinaryInputFile* binaryInputFile){
    setFileOffset(binaryInputFile->currentOffset());

    if(!binaryInputFile->copyBytesIterate(&entry,Size__32_bit_Auxilary_Header)){
        PRINT_ERROR("Auxilary header (32) can not be read");
    }
    return Size__32_bit_Auxilary_Header;
}

uint32_t AOutHeader64::read(BinaryInputFile* binaryInputFile){
    setFileOffset(binaryInputFile->currentOffset());

    if(!binaryInputFile->copyBytesIterate(&entry,Size__64_bit_Auxilary_Header)){
        PRINT_ERROR("Auxilary header (64) can not be read");
    }
    return Size__64_bit_Auxilary_Header;
}
