#ifndef _BasicBlockCounter_h_
#define _BasicBlockCounter_h_

#include <CommonMethods.h>

class BasicBlockCounter : public CommonMethods {
protected:
public:
    BasicBlockCounter(XCoffFile* xcoff,char* extension,uint32_t phaseNo);
    virtual ~BasicBlockCounter() { }

    void selectInstrumentationPoints(char* blockFile);

    uint32_t maxByteCountPerInst()        { return 32 * sizeof(uint32_t); }
    uint32_t byteCountForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect);
    uint32_t generateCodeForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect,
                                 BaseGen* gen,uint32_t genBufferOffset);
    uint32_t bytesPerBufferEntry() { return sizeof(uint64_t); }
    uint32_t howManyBufferEntry()  { return numberOfInstPoints; }
    bool     filterBlockForInst(BasicBlock* bb);
    char*    getSharedLibFuncName(uint32_t i){
        ASSERT(i < getNumOfSharedLibFuncs());
        return "MetaSim_endFuncCall_Freq";
    }
    char* getGenClassName() { return "BasicBlockCounter"; }
    uint32_t spaceForBlockInfo()   { return 0; }
    void getSharedLibraryPathAndObj(char** path,char** name,char** obj);
	void initializeReservedData(DataSection* dataSect,BaseGen* gen);

};

#endif /* _BasicBlockCounter_h_ */
