#ifndef _BasicBlockTracer_h_
#define _BasicBlockTracer_h_

#include <CommonMethods.h>

class BasicBlockTracer : public CommonMethods {
protected:
    uint32_t* allBlockInfo;
    uint64_t blockPointerOffset;
public:
    BasicBlockTracer(XCoffFile* xcoff,char* extension,uint32_t phaseNo);
    virtual ~BasicBlockTracer() { }

    void selectInstrumentationPoints(char* blockFile);

    uint32_t maxByteCountPerInst()        { return 32 * sizeof(uint32_t); }
    uint32_t byteCountForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect);
    uint32_t generateCodeForInst(uint32_t instPointIdx,uint64_t instStubAddress,TextSection* textSect,
                                 BaseGen* gen,uint32_t genBufferOffset);
    bool     filterBlockForInst(BasicBlock* bb);
    uint32_t howManyBufferEntry()  { return 0; }
    char*    getSharedLibFuncName(uint32_t i){
        ASSERT(i < getNumOfSharedLibFuncs());
        return "MetaSim_allFuncCall_Exec";
    }
    char* getGenClassName() { return "BasicBlockTracer"; }
    void reserveDataForInstrumentation();
    uint32_t generateSharedLibFuncWrapper(uint32_t libFuncIdx,uint64_t funcCallAddr,
                            uint32_t genBufferOffset,BaseGen* gen);
    uint32_t getBlockPointerOffset(uint32_t idx) 
        { return (int32_t)(allBlockInfo[idx] - execTOCAddress - tocDistUpdateVal); }
    void initializeReservedData(DataSection* dataSect,BaseGen* gen);
    uint32_t getBlockPointerOffsetSaveOffset() 
        { return (int32_t)(blockPointerOffset - execTOCAddress - tocDistUpdateVal); }
    void getSharedLibraryPathAndObj(char** path,char** name,char** obj);
};

#endif /* _BasicBlockTracer_h_ */
