#include <SectHeader.h>
#include <Iterator.h>
#include <Function.h>
#include <LineInfoFinder.h>
#include <XCoffFile.h>
#include <DataExtender.h>

DataExtender::DataExtender(XCoffFile* xcoff,char* extension)
    : XCoffFileGen(xcoff,extension,0,NULL)
{
    selectInstrumentationPoints(NULL);
    reserveDataForInstrumentation();
}

void DataExtender::verify(uint32_t written){
    PRINT_INFOR("Verifying the two files are identical");
}

void DataExtender::reserveDataForInstrumentation() {

    dataBufferEntryCount = 0;

    uint32_t dataSectionSize = xcoffFile->getDataSectionSize();
    uint64_t dataSectionBeginAddr = xcoffFile->getDataSectionVAddr();

    uint64_t currentFreeAddress = dataSectionBeginAddr + dataSectionSize;
    currentFreeAddress = nextAlignAddressWord(currentFreeAddress);
    currentFreeAddress += (0x2000*sizeof(uint32_t));

    extendedDataSize = currentFreeAddress - (dataSectionBeginAddr + dataSectionSize);
}
