#include <SectHeader.h>
#include <Iterator.h>
#include <Function.h>
#include <LineInfoFinder.h>
#include <XCoffFile.h>
#include <IdenticalInstrumentor.h>

IdenticalInstrumentor::IdenticalInstrumentor(XCoffFile* xcoff,char* extension)
    : XCoffFileGen(xcoff,extension,0,NULL)
{
    selectInstrumentationPoints(NULL);
    reserveDataForInstrumentation();
}

void IdenticalInstrumentor::verify(uint32_t written){

    ASSERT(xcoffFile->getFileSize() == getInstrumentedFileSize());
    ASSERT(written == getInstrumentedFileSize());

    PRINT_INFOR("Verifying the two files are identical");

    char* origFile = xcoffFile->getXCoffFileName();
    char* instFile = outputFileName;

    fileHeaderGen->verifyIdentical(origFile,instFile);
    aOutHeaderGen->verifyIdentical(origFile,instFile);
    for(uint32_t i=1;i<=numberOfSections;i++){
        sectHeadersGen[i]->verifyIdentical(origFile,instFile);
    }
    for(uint32_t i=1;i<=numberOfSections;i++){
        rawSectionsGen[i]->verifyIdentical(origFile,instFile);
    }
    for(uint32_t i=1;i<=numberOfSections;i++){
        if(relocationTablesGen[i]){
            relocationTablesGen[i]->verifyIdentical(origFile,instFile);
        }
    }
    for(uint32_t i=1;i<=numberOfSections;i++){
        if(lineInfoTablesGen[i]){
            lineInfoTablesGen[i]->verifyIdentical(origFile,instFile);
        }
    }
    symbolTableGen->verifyIdentical(origFile,instFile);
    stringTableGen->verifyIdentical(origFile,instFile);
}
